/*
 * nv_set_length.c
 *       novasub rouitines
 *              version 1.10sk  15-May-1995  Yasuo Takeuchi     (ICRR)
 */

#include "novalib.h"
#include "nova.h"

/*
 * nova_set_length()
 *
 */
int nova_set_length(nd, length)
     struct NOVAD *nd; int length;
{
    int rval,offset,size,pid, count;

    /* cancel ready buffers */
    count = 0;
    while (count < NV_MSGRCV_COUNT && 
	   msgrcv(nd->rcv_msgid,nd->buffer, NV_MSGLEN, 
		  nd->rcv_type,IPC_NOWAIT) < 0)
      count++;

    if (count >= NV_MSGRCV_COUNT) {
	fprintf(stderr, 
	  "nova_set_length: can't cancel previous buffer!  count=%d\n",
		count);
	return -1;
    }
#ifdef DEBUG
    if (count >= NV_MSGRCV_COUNT)
      printf("there is no buffer! to be canceled\n");
    else
      printf("CANCEL: count=%d  %s\n", count, nd->buffer->mtext);
#endif

    /* change buffer length */
    nd->buffer->mtype = nd->snd_type;
    sprintf(nd->buffer->mtext,"length:%d:%d:%d",nd->pid,nd->novaid,length);
    rval = msgsnd(nd->snd_msgid, nd->buffer, NV_MSGLEN, 0);
    if (rval < 0) {
	perror("nv_set_length: send message");
	return -1;
    }

    return 0;
}


