/*
 * net_analyzer.c
 *                   Simple analyzer for net nova development
 *
 *              version 1.03  09-OCT-1992 M. Nomachi (KEK)
 *
 */
#include "nova.h"
#include "novanet.h"

#define DEFAULT_HOST     "psuxnc"
#define DEFAULT_NAME     "/tmp/nova"
#define DEFAULT_PRI      10
#define DEFAULT_SLEEP    1

int data[16*1024];

main(argc, argv) int argc; char *argv[]; {
  struct NOVAD *nd;
  char host[NOVA_HOSTNAME_MAX + 1];
  char name[NV_MAXNAME + 1];
  int length, priority;
  int status, loop, i, sleep_time;
  int get_count, skip_count;
  
  /* Read options */
  strcpy(host, (argc > 1) ? argv[1] : DEFAULT_HOST);
  strcpy(name, (argc > 2) ? argv[2] : DEFAULT_NAME);
  priority   = (argc > 3) ? atoi(argv[3]) : DEFAULT_PRI;
  sleep_time = (argc > 4) ? atoi(argv[4]) : DEFAULT_SLEEP;
  
  /* open NOVA */
  if ((int)(nd = net_nova_open(host, 0, name, priority,1)) == -1) {
    printf("net analyzer: cannot open %s:%s\n", host, name);
    exit(1);
  }
  
  get_count = 0;
  skip_count = 0;
  loop = 0;
  while(1) {
    alarm(10);
    status = net_nova_read(nd, data, sizeof(data));
    if (status > 0) {   /* nomal */
      skip_count += (data[0]-loop-1);
      loop = data[0];
      get_count++;
      printf("analyzer: count=%d/%d  length=%d byte",
	     get_count,get_count+skip_count, status);
      for(i = 0; i < 3; i++) printf(" %8X", data[i]);
      printf("\n");

      if ((sleep_time >0) && (sleep_time<60)) sleep(sleep_time);
    }
    else if (status == 0) {   /* Interrupted */
      printf("analyzer: interrupted!\n");
      get_count = 0;
      skip_count = 0;
      loop = 0;
    }
    else {  /* error */
      printf("net analyzer: error! %d\n",status);
      break;
    }
  }
  printf("net analyzer: nomal end.\n");
  net_nova_close(nd);
}

