/*
 * rxtest.c
 *
 * Nova buffer manager network daemon test program
 *
 *              version 1.03  08-OCT-1992 Masaharu NOMACHI   (KEK online)
 */

#include "novand.h"

char data[] ={"rx:/tmp/nova:10:1:"};
int buf[1024*1024];

main(argc,argv) int argc; int **argv; {

  int sock, size, sig, loop, i, rval;
  struct sockaddr_in server;
  struct hostent *hp, *gethostbyname();
  char header[24];
  
  size = 1024;
  sig = 50;

  /* Create socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
    printf("** ERROR ** opening stream socket. errno=%X\n",errno);
    exit(1);
  }

  /* Connect socket using name specified by command line. */
  server.sin_family = AF_INET;
  hp = gethostbyname(argv[1]);
  if ( hp == 0 ) {
    printf("** ERROR ** %s: unknown host\n",argv[1]);
    exit(2);
  }
  /* BSD version
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  */
  memcpy(&server.sin_addr, hp->h_addr, hp->h_length);
  if (argc>2) server.sin_port = htons(atoi(argv[2]));
  else        server.sin_port = htons(NOVA_PORT);

  if (connect(sock, &server, sizeof(server)) < 0) {
    printf("** ERROR ** connecting stream socket%X\n",errno);
    exit(1);
  }

  printf(" socket %d\n",sock);

  if (write(sock, data, sizeof(data)) < 0)
    printf("** ERROR ** writing on stream socket%X\n",errno);
  
  wait_ack(sock);

  for(loop=1;1;loop++) {
    for(i=0; i < (size>>2); i++) buf[i] = loop+i;
    sprintf(header,"nova:%08X:%08X:\0",size,sig);
    if ((rval = write(sock,header,sizeof(header))) <=0) break;
    if ((rval = write(sock,buf,  size)          ) <=0) break;
    printf("net rxtest %d  %d\n",loop,rval);
    sleep(3);
  }
  if (rval==0) 
    printf("** Connection close **\n");
  else if (rval<0)
    printf("** ERROR ** writing on stream socket%X\n",errno);
  else
    printf("** ERROR ** \n",rval);
  close(sock);
}

wait_ack(msgsock) int msgsock; {
  char buff[32];
  int rval;
  rval = read(msgsock,buff,sizeof(buff));
  if (rval <=0) return rval;
  return rval;
}


