/*
 * nnv_open.c
 *                 novanetsub rouitines
 *
 *              version 1.03  09-OCT-1992 Masaharu NOMACHI    (KEK)
 */

#include "novanet.h"
#include "nova.h"

char ack[] ={"ack:"};

/**************************************
 * net_nova_open                      *
 *   positive priority : consumer     *
 *   negative priority : producer     *
 **************************************/
struct NOVAD *net_nova_open(host, port, name, priority,request)
     char *host, *name; int port, priority, request;
{
  struct NOVAD *nd;
  int rval, sd;
  int pid;
  struct sockaddr_in server;
  char *buffer, *malloc();
  char *function;
  int nnv_dumy();
  struct hostent *hp, *gethostbyname();

  function = (char *)signal(SIGALRM,nnv_dumy);
  if ((void (*)())function != SIG_DFL) signal(SIGALRM,function);

  /*
   * get nova descriptor area
   */
  if ((int)(nd = (struct NOVAD *)malloc(sizeof(struct NOVAD))) == 0)
    return (struct NOVAD *)(-1);

  /*
   * get message buffer area
   */
  if ((int)(buffer = malloc(NV_NET_MSGLEN)) == 0) {
    free(nd);
    return (struct NOVAD *)(-1);
  }
  nd->net_msg = buffer;
  nd->sd      = 0;

  /*
   * create socket
   */
  if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("nnv_open: opening stream socket");
    free(nd);
    return (struct NOVAD *)(-1);
  }
  nd->sd = sd;

  /*
   * connect socket
   */
  server.sin_family = AF_INET;
  hp = gethostbyname(host);
  if ( hp == 0 ) {
    printf("nnv_open: unknown host (%s)\n",host);
    net_nova_close(nd);
    return (struct NOVAD *)(-1);
  }
  /* BSD version 
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  */
  memcpy(&server.sin_addr, hp->h_addr, hp->h_length);
  if (port!=0) server.sin_port = htons(port);
  else         server.sin_port = htons(NOVA_PORT);

  if (connect(sd, &server, sizeof(server)) < 0) {
    perror("nnv_open: connecting stream socket");
    net_nova_close(nd);
    return (struct NOVAD *)(-1);
  }
  
  /*
   * send pid and priority to nova net daemon
   */
  pid = getpid();
  nd->pid = pid;
  nd->priority = priority;
  nd->request  = request;

  if (priority > 0)
    sprintf(buffer, "tx:%s:%d:%d:",name,priority,request);
  else
    sprintf(buffer, "rx:%s:%d:%d:",name,-priority,request);

  if (write(sd, buffer, strlen(buffer)) < 0) {
    perror("nnv_open: writing on stream socket");
    net_nova_close(nd);
    return (struct NOVAD *)(-1);
  }

  /*
   * Wait ack
   */
  rval = read(sd,buffer,sizeof(buffer));
  if (rval <= 0 )  {
    printf("rval = %d %s\n",rval,buffer);
    net_nova_close(nd);
    return (struct NOVAD *)(-1);
  }
  if (strncmp(buffer,ack,4)==0) return nd;
  else                          return (struct NOVAD *)(-1);
}


nnv_dumy() {
  return 0;
}
