/*
 * bufmgr_dump.c
 *
 * Nova buffer manager data base dump
 *              version 1.01  25-SEP-1992 Masaharu NOMACHI   (KEK)
 *              version 1.06   1-APR-1993 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.10   2-Jul-1993 Yasuo TAKEUCHI     (T.I.T.)
 */

#include "novad.h"
#include "bm_exec.h"
#include "bm.h"

extern struct EXEC_process *consumer, *wait_producer, *busy_producer;
extern struct EXEC_buffer *free_buffer;

/*
 * nova data base dump for diagnostic
 */
int nova_dump(nd)  struct nova_def *nd; {
  struct msgbuf *m;
  m = (struct msgbuf *)malloc(100);
  if ((int)nd==0) printf("******* NOVA DUMP ********\n");
  b_dump(nd,m,free_buffer,  "Free data buffer");
  p_dump(nd,m,wait_producer,"Wait producer");
  p_dump(nd,m,busy_producer,"Busy producer");
  p_dump(nd,m,consumer,     "Consumer");
#ifdef DEBUG

#else
  if ((int)nd!=0) {
      sprintf(m->mtext,"end:");
      send_daemon(nd,m);
  }
#endif
  return 0;
}

p_dump(nd,m,top,message)
     struct nova_def *nd; struct msgbuf *m;
     struct EXEC_process *top; char *message; 
{
  struct EXEC_process *p;
  int i;
  
  if (top == NULL_process) return;
  if ((int)nd==0) printf("***** %s *****\n",message);
  /* count total processes */
  p = top->next;
  for (i = 1; p != top && i < 10000; i++) {
      p = p->next;
  }
  printf("Total %s = %3d\n", message, i);
 
  p = top;
  for(i=0;i<10;i++) {
    sprintf(m->mtext,"dump: %s | novaid=%4d priority=%7d request=%3d",
	    message,p->table->id,p->priority,p->n_request);
    if ((int)nd == 0) 
      printf("%s\n",index(m->mtext,'|'));
    /* System V
      printf("%s\n",strchr(m->mtext,'|'));
    */
#ifdef DEBUG

#else
    else 
      send_daemon(nd,m);
#endif
    b_dump(nd,m,p->active,"active");
    b_dump(nd,m,p->wait,  "wait  ");
    p = p->next;
    if (p==top) break;
  }
  return;
}

b_dump(nd,m,top,message)
     struct nova_def *nd; struct msgbuf *m;
     struct EXEC_buffer *top; char *message; 
{
  struct EXEC_buffer *b;
  int i;

  if (top==NULL_buffer) return;
  if ((int)nd==0) printf("*****     %s *****\n",message);
  /* count total buffers */
  b = top->next;
  for (i = 1; b != top && i < 10000; i++) {
      b = b->next;
  }
  printf("Total %s = %3d\n", message, i);
 
  b = top;
  for(i=0;i<5;i++) {
    if ((int)nd==0) 
        printf(" ->%5d",b->table->id);
    else {
#ifdef DEBUG
	fprintf(stderr, "dump: %s | id=%4d sig=%7d  size=%7d  offset=%d\n",
		message,b->table->id,b->significance, b->max_size, b->offset);
#else
	sprintf(m->mtext,"dump: %s | id=%4d sig=%7d  size=%7d  offset=%d",
		message,b->table->id,b->significance, b->max_size, b->offset);
	send_daemon(nd,m); 
#endif
    }
    b = b->next;
    if (b==top) break;
    if (((int)nd==0)&&((i%5)==4)) printf("\n");
  }
  if ((int)nd==0) printf("\n");
  return;
}
